import * as React from "react";
import { ExtractRoutesParams, GetNestedRoutes, Location, ParamsArg, PrependBasePath, Simplify, Subscription } from "./types";
export { decodeSearch, encodeSearch } from "./search";
export type { Location, Search } from "./types";
export declare const createRouter: <Routes extends Record<string, string>, BasePath extends string = string>(routes: Readonly<Routes>, options?: {
    basePath?: BasePath;
    blockerMessage?: string;
}) => {
    readonly location: Location;
    createURL: <RouteName extends Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeName: RouteName, ...args: ParamsArg<ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>[RouteName]>) => string;
    goBack: () => void;
    goForward: () => void;
    navigate: <RouteName_1 extends Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeName: RouteName_1, ...args: ParamsArg<ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>[RouteName_1]>) => void;
    replace: <RouteName_2 extends Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeName: RouteName_2, ...args: ParamsArg<ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>[RouteName_2]>) => void;
    subscribe: (subscription: Subscription) => (() => void);
    unsafeNavigate: (url: string) => void;
    unsafeReplace: (url: string) => void;
    useLink: ({ href, replace, target, }: {
        href: string;
        replace?: boolean | undefined;
        target?: React.HTMLAttributeAnchorTarget | undefined;
    }) => {
        active: boolean;
        onClick: (event: React.MouseEvent) => void;
    };
    useLocation: () => Location;
    useRoute: <RouteName_3 extends keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>> | Exclude<keyof Routes, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>(routeNames: readonly RouteName_3[]) => RouteName_3 extends string ? {
        name: RouteName_3;
        params: Simplify<(ExtractRoutesParams<GetNestedRoutes<PrependBasePath<Routes, BasePath>>> & ExtractRoutesParams<Omit<PrependBasePath<Routes, BasePath>, keyof GetNestedRoutes<PrependBasePath<Routes, BasePath>>>>)[RouteName_3]>;
    } | undefined : never;
    useBlocker: (blocked: boolean, message?: string) => void;
};
